/*
 * Svix API
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * API version: 1.1.1
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// MessageBroadcastIn struct for MessageBroadcastIn
type MessageBroadcastIn struct {
	// List of free-form identifiers that endpoints can filter by
	Channels []string `json:"channels,omitempty"`
	// Optional unique identifier for the message
	EventId NullableString `json:"eventId,omitempty"`
	// The event type's name
	EventType string `json:"eventType"`
	Payload map[string]interface{} `json:"payload"`
	PayloadRetentionPeriod *int64 `json:"payloadRetentionPeriod,omitempty"`
}

// NewMessageBroadcastIn instantiates a new MessageBroadcastIn object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageBroadcastIn(eventType string, payload map[string]interface{}) *MessageBroadcastIn {
	this := MessageBroadcastIn{}
	this.EventType = eventType
	this.Payload = payload
	var payloadRetentionPeriod int64 = 90
	this.PayloadRetentionPeriod = &payloadRetentionPeriod
	return &this
}

// NewMessageBroadcastInWithDefaults instantiates a new MessageBroadcastIn object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageBroadcastInWithDefaults() *MessageBroadcastIn {
	this := MessageBroadcastIn{}
	var payloadRetentionPeriod int64 = 90
	this.PayloadRetentionPeriod = &payloadRetentionPeriod
	return &this
}

// GetChannels returns the Channels field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MessageBroadcastIn) GetChannels() []string {
	if o == nil  {
		var ret []string
		return ret
	}
	return o.Channels
}

// GetChannelsOk returns a tuple with the Channels field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MessageBroadcastIn) GetChannelsOk() (*[]string, bool) {
	if o == nil || o.Channels == nil {
		return nil, false
	}
	return &o.Channels, true
}

// HasChannels returns a boolean if a field has been set.
func (o *MessageBroadcastIn) HasChannels() bool {
	if o != nil && o.Channels != nil {
		return true
	}

	return false
}

// SetChannels gets a reference to the given []string and assigns it to the Channels field.
func (o *MessageBroadcastIn) SetChannels(v []string) {
	o.Channels = v
}

// GetEventId returns the EventId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MessageBroadcastIn) GetEventId() string {
	if o == nil || o.EventId.Get() == nil {
		var ret string
		return ret
	}
	return *o.EventId.Get()
}

// GetEventIdOk returns a tuple with the EventId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MessageBroadcastIn) GetEventIdOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return o.EventId.Get(), o.EventId.IsSet()
}

// HasEventId returns a boolean if a field has been set.
func (o *MessageBroadcastIn) HasEventId() bool {
	if o != nil && o.EventId.IsSet() {
		return true
	}

	return false
}

// SetEventId gets a reference to the given NullableString and assigns it to the EventId field.
func (o *MessageBroadcastIn) SetEventId(v string) {
	o.EventId.Set(&v)
}
// SetEventIdNil sets the value for EventId to be an explicit nil
func (o *MessageBroadcastIn) SetEventIdNil() {
	o.EventId.Set(nil)
}

// UnsetEventId ensures that no value is present for EventId, not even an explicit nil
func (o *MessageBroadcastIn) UnsetEventId() {
	o.EventId.Unset()
}

// GetEventType returns the EventType field value
func (o *MessageBroadcastIn) GetEventType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.EventType
}

// GetEventTypeOk returns a tuple with the EventType field value
// and a boolean to check if the value has been set.
func (o *MessageBroadcastIn) GetEventTypeOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.EventType, true
}

// SetEventType sets field value
func (o *MessageBroadcastIn) SetEventType(v string) {
	o.EventType = v
}

// GetPayload returns the Payload field value
func (o *MessageBroadcastIn) GetPayload() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}

	return o.Payload
}

// GetPayloadOk returns a tuple with the Payload field value
// and a boolean to check if the value has been set.
func (o *MessageBroadcastIn) GetPayloadOk() (*map[string]interface{}, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Payload, true
}

// SetPayload sets field value
func (o *MessageBroadcastIn) SetPayload(v map[string]interface{}) {
	o.Payload = v
}

// GetPayloadRetentionPeriod returns the PayloadRetentionPeriod field value if set, zero value otherwise.
func (o *MessageBroadcastIn) GetPayloadRetentionPeriod() int64 {
	if o == nil || o.PayloadRetentionPeriod == nil {
		var ret int64
		return ret
	}
	return *o.PayloadRetentionPeriod
}

// GetPayloadRetentionPeriodOk returns a tuple with the PayloadRetentionPeriod field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageBroadcastIn) GetPayloadRetentionPeriodOk() (*int64, bool) {
	if o == nil || o.PayloadRetentionPeriod == nil {
		return nil, false
	}
	return o.PayloadRetentionPeriod, true
}

// HasPayloadRetentionPeriod returns a boolean if a field has been set.
func (o *MessageBroadcastIn) HasPayloadRetentionPeriod() bool {
	if o != nil && o.PayloadRetentionPeriod != nil {
		return true
	}

	return false
}

// SetPayloadRetentionPeriod gets a reference to the given int64 and assigns it to the PayloadRetentionPeriod field.
func (o *MessageBroadcastIn) SetPayloadRetentionPeriod(v int64) {
	o.PayloadRetentionPeriod = &v
}

func (o MessageBroadcastIn) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Channels != nil {
		toSerialize["channels"] = o.Channels
	}
	if o.EventId.IsSet() {
		toSerialize["eventId"] = o.EventId.Get()
	}
	if true {
		toSerialize["eventType"] = o.EventType
	}
	if true {
		toSerialize["payload"] = o.Payload
	}
	if o.PayloadRetentionPeriod != nil {
		toSerialize["payloadRetentionPeriod"] = o.PayloadRetentionPeriod
	}
	return json.Marshal(toSerialize)
}

type NullableMessageBroadcastIn struct {
	value *MessageBroadcastIn
	isSet bool
}

func (v NullableMessageBroadcastIn) Get() *MessageBroadcastIn {
	return v.value
}

func (v *NullableMessageBroadcastIn) Set(val *MessageBroadcastIn) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageBroadcastIn) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageBroadcastIn) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageBroadcastIn(val *MessageBroadcastIn) *NullableMessageBroadcastIn {
	return &NullableMessageBroadcastIn{value: val, isSet: true}
}

func (v NullableMessageBroadcastIn) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageBroadcastIn) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


